## mle 1.3

=== Makefile ===
prefix?=/usr/local

mle_cflags:=-std=c99 -Wall -Wextra -pedantic -Wno-pointer-arith -Wno-unused-result -Wno-unused-parameter -g -O3 -D_GNU_SOURCE -I.  $(CFLAGS)
mle_ldflags:=$(LDFLAGS)
mle_libs:=-lpcre -ltermbox -llua5.3
mle_ldlibs:=-lm $(LDLIBS)
mle_objects:=$(patsubst %.c,%.o,$(wildcard *.c))
mle_objects_no_main:=$(filter-out main.o,$(mle_objects))
mle_func_tests:=$(wildcard tests/func/test_*.sh))
mle_unit_tests:=$(patsubst %.c,%,$(wildcard tests/unit/*.c))
mle_link_default:=-Wl,-Bdynamic
mle_vendor_deps:=

ifdef mle_static
  mle_static_var:=-static
  mle_link_default:=-static
endif

ifdef mle_vendor
  mle_ldlibs:=-Wl,-Bstatic $(mle_libs) $(mle_link_default) $(mle_ldlibs)
  mle_ldflags:=-Lvendor/pcre/.libs -Lvendor/termbox/src -Lvendor/lua $(mle_ldflags)
  mle_cflags:=-Ivendor/pcre -Ivendor/termbox/src -Ivendor -Ivendor/uthash/src $(mle_cflags)
  mle_vendor_deps:=./vendor/pcre/.libs/libpcre.a ./vendor/termbox/src/libtermbox.a ./vendor/lua/liblua5.3.a
else
  mle_ldlibs:=$(mle_libs) $(mle_ldlibs)
endif

all: mle

mle: $(mle_vendor_deps) $(mle_objects)
	$(CC) $(mle_static_var) $(mle_cflags) $(mle_objects) $(mle_ldflags) $(mle_ldlibs) -o mle

$(mle_objects): %.o: %.c
	$(CC) -c $(mle_cflags) $< -o $@

$(mle_vendor_deps):
	$(MAKE) -C vendor

$(mle_unit_tests): %: %.c
	$(CC) $(mle_cflags) $(mle_objects_no_main) $(mle_ldflags) $(mle_ldlibs) $< -o $@

test: mle $(mle_unit_tests)
	./mle -v && export MLE=$$(pwd)/mle && $(MAKE) -C tests

sloc:
	find . -name '*.c' -or -name '*.h' | \
		grep -Pv '(termbox|test|ut|lua)' | \
		xargs -rn1 cat | \
		wc -l

install: mle
	install -D -v -m 755 mle $(DESTDIR)$(prefix)/bin/mle

uscript:
	php uscript.inc.php >uscript.inc

clean:
	rm -f mle $(mle_objects) $(mle_vendor_deps) $(mle_unit_tests)
	$(MAKE) -C vendor clean

.PHONY: all test sloc install uscript clean

=== debian/changelog ===
mle (1.3-2) unstable; urgency=medium

  * Cherry pick commits from 0d51b0d to af76670 to fix portability.

 -- Adam Saponara <as@php.net>  Mon, 31 Dec 2018 15:37:42 -0500

mle (1.3-1) unstable; urgency=medium

  * Initial release (Closes: #908093)

 -- Adam Saponara <as@php.net>  Fri, 21 Dec 2018 12:52:44 -0500

=== debian/control ===
Source: mle
Section: editors
Priority: optional
Maintainer: Adam Saponara <as@php.net>
Build-Depends: debhelper (>= 11), libpcre3-dev, uthash-dev, liblua5.3-dev, libtermbox-dev
Standards-Version: 4.2.1
Vcs-Git: https://github.com/adsr/mle.git
Vcs-Browser: https://github.com/adsr/mle
Homepage: https://github.com/adsr/mle

Package: mle
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: fzf, tree
Suggests: less, universal-ctags, perl
Description: flexible terminal-based editor
 mle is a small, flexible, terminal-based text editor
 written in C. Notable features include: full Unicode
 support, syntax highlighting, scriptable rc file, macros,
 search and replace (PCRE), window splitting, multiple
 cursors, and integration with various shell commands.

## mle 1.4.3

=== Makefile ===
--- 
+++ 
@@ -2,27 +2,26 @@
 
 mle_cflags:=-std=c99 -Wall -Wextra -pedantic -Wno-pointer-arith -Wno-unused-result -Wno-unused-parameter -g -O3 -D_GNU_SOURCE -I.  $(CFLAGS)
 mle_ldflags:=$(LDFLAGS)
-mle_libs:=-lpcre -ltermbox -llua5.3
+mle_dynamic_libs:=-lpcre -ltermbox -llua5.3
+mle_static_libs:=vendor/pcre/.libs/libpcre.a vendor/termbox/src/libtermbox.a vendor/lua/liblua5.3.a
 mle_ldlibs:=-lm $(LDLIBS)
 mle_objects:=$(patsubst %.c,%.o,$(wildcard *.c))
 mle_objects_no_main:=$(filter-out main.o,$(mle_objects))
 mle_func_tests:=$(wildcard tests/func/test_*.sh))
 mle_unit_tests:=$(patsubst %.c,%,$(wildcard tests/unit/*.c))
-mle_link_default:=-Wl,-Bdynamic
 mle_vendor_deps:=
+mle_static_var:=
 
 ifdef mle_static
   mle_static_var:=-static
-  mle_link_default:=-static
 endif
 
 ifdef mle_vendor
-  mle_ldlibs:=-Wl,-Bstatic $(mle_libs) $(mle_link_default) $(mle_ldlibs)
-  mle_ldflags:=-Lvendor/pcre/.libs -Lvendor/termbox/src -Lvendor/lua $(mle_ldflags)
+  mle_ldlibs:=$(mle_static_libs) $(mle_ldlibs)
   mle_cflags:=-Ivendor/pcre -Ivendor/termbox/src -Ivendor -Ivendor/uthash/src $(mle_cflags)
-  mle_vendor_deps:=./vendor/pcre/.libs/libpcre.a ./vendor/termbox/src/libtermbox.a ./vendor/lua/liblua5.3.a
+  mle_vendor_deps:=$(mle_static_libs)
 else
-  mle_ldlibs:=$(mle_libs) $(mle_ldlibs)
+  mle_ldlibs:=$(mle_dynamic_libs) $(mle_ldlibs)
 endif
 
 all: mle

=== debian/changelog ===
mle (1.4.3-2) unstable; urgency=medium

  * Build fixes

 -- Adam Saponara <as@php.net>  Tue, 18 Feb 2020 15:54:57 -0500

mle (1.4.3-1) unstable; urgency=medium

  * New upstream release
  * Remove patches
  * Switch to semantic versioning

 -- Adam Saponara <as@php.net>  Thu, 13 Feb 2020 22:30:22 -0500

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Adam Saponara <as@php.net>
 Build-Depends: debhelper (>= 11), libpcre3-dev, uthash-dev, liblua5.3-dev, libtermbox-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.5.0
 Vcs-Git: https://github.com/adsr/mle.git
 Vcs-Browser: https://github.com/adsr/mle
 Homepage: https://github.com/adsr/mle

## mle 1.5.0

=== tests/Makefile ===
all:
	./run.sh

.PHONY: all

=== vendor/Makefile ===
lua_cflags:=-std=c99 -Wall -Wextra -pedantic -g -O3 -DLUA_USE_POSIX $(CFLAGS)
lua_objects:=$(patsubst lua/%.c,lua/%.o,$(filter-out lua/lua.c lua/onelua.c, $(wildcard lua/*.c)))

all: uthash/src/utlist.h pcre/.libs/libpcre.a lua/liblua5.4.a

uthash/src/utlist.h:
	command -v git && git submodule update --init

pcre/.libs/libpcre.a:
	cd pcre && ./autogen.sh && ./configure && $(MAKE)

lua/liblua5.4.a: $(lua_objects)
	$(AR) rcs $@ $(lua_objects)

$(lua_objects): %.o: %.c
	$(CC) -c $(lua_cflags) $< -o $@

clean:
	rm -f lua/liblua5.4.a $(lua_objects)
	rm -f pcre/config.h.in~
	-$(MAKE) -C pcre clean

.PHONY: all clean

=== debian/tests/control ===
Test-Command: make test
Depends: @, @builddeps@
Restrictions: allow-stderr

## mle 1.7.2

=== Makefile ===
prefix?=/usr/local

mle_cflags:=-std=c99 -Wall -Wextra -pedantic -Wno-pointer-arith -Wno-unused-result -Wno-unused-parameter -g -O0 -D_GNU_SOURCE -DPCRE2_CODE_UNIT_WIDTH=8 -I. $(CFLAGS)
mle_ldflags:=$(LDFLAGS)
mle_dynamic_libs:=-lpcre2-8 -llua5.4
mle_static_libs:=vendor/pcre2/.libs/libpcre2-8.a vendor/lua/liblua5.4.a
mle_ldlibs:=-lm $(LDLIBS)
mle_objects:=$(patsubst %.c,%.o,$(wildcard *.c))
mle_objects_no_main:=$(filter-out main.o,$(mle_objects))
mle_func_tests:=$(wildcard tests/func/test_*.sh))
mle_unit_tests:=$(patsubst %.c,%,$(wildcard tests/unit/test_*.c))
mle_unit_test_objects:=$(patsubst %.c,%.o,$(wildcard tests/unit/test_*.c))
mle_unit_test_all:=tests/unit/test
mle_vendor_deps:=
mle_static_var:=

ifdef mle_static
  mle_static_var:=-static
endif

ifdef mle_vendor
  mle_ldlibs:=$(mle_static_libs) $(mle_ldlibs)
  mle_cflags:=-Ivendor/pcre2/src -Ivendor -Ivendor/uthash/src $(mle_cflags)
  mle_vendor_deps:=$(mle_static_libs)
else
  mle_ldlibs:=$(mle_dynamic_libs) $(mle_ldlibs)
endif

all: mle

mle: $(mle_vendor_deps) $(mle_objects) termbox2.h
	$(CC) $(mle_static_var) $(mle_cflags) $(mle_objects) $(mle_ldflags) $(mle_ldlibs) -o mle

$(mle_objects): %.o: %.c
	$(CC) -c $(mle_cflags) $< -o $@

$(mle_vendor_deps):
	$(MAKE) -C vendor

$(mle_unit_test_objects): %.o: %.c
	$(CC) -DTEST_NAME=$(basename $(notdir $<)) -c $(mle_cflags) -rdynamic $< -o $@

$(mle_unit_test_all): $(mle_objects_no_main) $(mle_unit_test_objects) $(mle_unit_test_all).c
	$(CC) $(mle_cflags) -rdynamic $(mle_unit_test_all).c $(mle_objects_no_main) $(mle_unit_test_objects) $(mle_ldflags) $(mle_ldlibs) -ldl -o $@

$(mle_unit_tests): %: $(mle_unit_test_all)
	{ echo "#!/bin/sh"; echo "$(abspath $(mle_unit_test_all)) $(notdir $@)"; } >$@ && chmod +x $@

test: mle $(mle_unit_tests)
	./mle -v && export MLE=$$(pwd)/mle && $(MAKE) -C tests

sloc:
	find . -name '*.c' -or -name '*.h' | \
		grep -Pv '(termbox|test|ut|lua)' | \
		xargs -rn1 cat | \
		wc -l

install: mle
	install -v -d $(DESTDIR)$(prefix)/bin
	install -v -m 755 mle $(DESTDIR)$(prefix)/bin/mle

uscript:
	php uscript.inc.php >uscript.inc

clean_quick:
	rm -f mle $(mle_objects) $(mle_unit_test_objects) $(mle_unit_tests) $(mle_unit_test_all)

clean:
	rm -f mle $(mle_objects) $(mle_vendor_deps) $(mle_unit_test_objects) $(mle_unit_tests) $(mle_unit_test_all)
	$(MAKE) -C vendor clean

.PHONY: all test sloc install uscript clean

=== vendor/Makefile ===
lua_cflags:=-std=c99 -Wall -Wextra -pedantic -g -O3 -DLUA_USE_POSIX $(CFLAGS)
lua_objects:=$(patsubst lua/%.c,lua/%.o,$(filter-out lua/lua.c lua/onelua.c, $(wildcard lua/*.c)))

all: uthash/src/utlist.h pcre2/.libs/libpcre2-8.a lua/liblua5.4.a

uthash/src/utlist.h:
	command -v git && git submodule update --init

pcre2/.libs/libpcre2-8.a:
	cd pcre2 && ./autogen.sh && ./configure && $(MAKE)

lua/liblua5.4.a: $(lua_objects)
	$(AR) rcs $@ $(lua_objects)

$(lua_objects): %.o: %.c
	$(CC) -c $(lua_cflags) $< -o $@

clean:
	rm -f lua/liblua5.4.a $(lua_objects)
	rm -f pcre2/src/config.h.in~
	-$(MAKE) -C pcre2 clean

.PHONY: all clean

=== debian/changelog ===
mle (1.7.2-1) unstable; urgency=medium

  * New upstream release

 -- Adam Saponara <as@php.net>  Sun, 24 May 2023 20:22:31 -0400

mle (1.5.0-1) unstable; urgency=medium

  * New upstream release

 -- Adam Saponara <as@php.net>  Sun, 29 May 2022 08:37:00 -0400

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: editors
 Priority: optional
 Maintainer: Adam Saponara <as@php.net>
-Build-Depends: debhelper (>= 11), libpcre3-dev, uthash-dev, liblua5.3-dev, libtermbox-dev
-Standards-Version: 4.5.0
+Build-Depends: debhelper (>= 11), libpcre2-dev, uthash-dev, liblua5.4-dev
+Standards-Version: 4.5.1
 Vcs-Git: https://github.com/adsr/mle.git
 Vcs-Browser: https://github.com/adsr/mle
 Homepage: https://github.com/adsr/mle
